# Aborting requests

All requests generated by Gangway are done through the
[superagent library](https://github.com/visionmedia/superagent). Superagent
exposes an `abort()` method for cancelling requests.

See http://visionmedia.github.io/superagent/#aborting-requests.

For example:

```javascript
var Gangway = require('gangway')

var API = Gangway()

API.resource('posts')

// Let's say we have an content management app. When the admin
// visits a post:
var request = posts.read({ params: { id: 2 }})

// But what if they go to another page? We no longer care about this
// request:
request.abort()
```

An important final note here is that `abort()` is not available after
chaining from a request using `then()`. At this point, the request has
been converted into a
[Promise](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise).
